<?php
/**
 * jmootips Joomla! Plugin
 * @author Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 * @copyright Copyright (C) 2013 Joachim Schmidt. All rights reserved.
 * @license	 http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 *
 * change activity:
 * 1.02.2015: Release V2.0.0 for Joomla 3.x
 * 1.10.2018: Use new Namespaced Joomla API
 */
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Version;

class plgsystemjsvisit_counterInstallerScript
{

	function postflight ($parent, $type)
	{
		$version = new Version();
		if (version_compare($version->getShortVersion(), '4.0', '>='))
			$db = Factory::getContainer()->get('DatabaseDriver');
		else
			$db = Factory::getDbo();
		
		if (version_compare($version->getShortVersion(), '3.2', '<'))
		{
			Factory::getApplication()->enqueueMessage(Text::_("PLG_RUNTIME_ERROR"), warning);
		}
		else
		{
			// Enable plugin
			$sql = " UPDATE  #__extensions SET enabled=1 WHERE type='plugin' AND element='jsvisit_counter' AND folder='system';";
			$db->setQuery($sql);
			$db->execute();
			
			// detete component if found
			$sql = " SELECT element from #__extensions WHERE type='component' AND element='com_jsvisit_counter'";
			$db->setQuery($sql);
			$db->execute();
			$result = $db->loadResult();
			if ($result)
			{
				$sql = " DELETE FROM  #__extensions WHERE type='component' AND element='com_jsvisit_counter';";
				$db->setQuery($sql);
				$db->execute();
				
				$sql = " DELETE FROM  #__assets WHERE name='com_jsvisit_counter';";
				$db->setQuery($sql);
				$db->execute();
				
				$sql = " DELETE FROM  #__menu WHERE title='COM_JSVISIT_COUNTER';";
				$db->setQuery($sql);
				$db->execute();
				
				$comp_dir = JPATH_ROOT . "/components/com_jsvisit_counter";
				$this->deleteDirectory($comp_dir);
				$comp_dir = JPATH_ROOT . "/administrator/components/com_jsvisit_counter";
				$this->deleteDirectory($comp_dir);
				Factory::getApplication()->enqueueMessage(sprintf(Text::_("PLG_DELETE_MSG"), 'com_jsvisit_counter'), 'notice');
			}
			
			// delete content plugin if found
			$sql = " SELECT element from #__extensions WHERE type='plugin' AND element='jsvisit_counter' AND folder='content';";
			$db->setQuery($sql);
			$db->execute();
			$result = $db->loadResult();
			if ($result)
			{
				$sql = " DELETE FROM  #__extensions WHERE type='plugin' AND element='jsvisit_counter' AND folder='content';";
				$db->setQuery($sql);
				$db->execute();
				
				$plugin_dir = JPATH_ROOT . "/plugins/content/jsvisit_counter";
				$this->deleteDirectory($plugin_dir);
				Factory::getApplication()->enqueueMessage(sprintf(Text::_("PLG_DELETE_MSG"), 'jsvisit_counter content plugin'), 'notice');
			}
		}
	}

	function deleteDirectory ($dirPath)
	{
		if (! is_dir($dirPath))
		{
			throw new InvalidArgumentException("$dirPath must be a directory");
		}
		if (substr($dirPath, strlen($dirPath) - 1, 1) != '/')
		{
			$dirPath .= '/';
		}
		$files = glob($dirPath . '*', GLOB_MARK);
		foreach ($files as $file)
		{
			if (is_dir($file))
			{
				self::deleteDirectory($file);
			}
			else
			{
				unlink($file);
			}
		}
		rmdir($dirPath);
	}
}

?>